<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>LibArch: Data Transfer API</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">LibArch
   </div>
   <div id="projectbrief">Library architecture and framework</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Data Transfer API</div>  </div>
</div><!--header-->
<div class="contents">

<p>LibArch Data Transfers API provides functions to perform data transfers between two memory locations which can be internal memory or external memory:  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../dd/da7/structlib__emt__Config__s.html">lib_emt_Config_s</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Configuration parameters for the initialization of external memory data transfer.  <a href="../../dd/da7/structlib__emt__Config__s.html#details">More...</a><br/></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d8/d98/structlib__emt__ConfigLarge__s.html">lib_emt_ConfigLarge_s</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Configuration for large external memory data transfers.  <a href="../../d8/d98/structlib__emt__ConfigLarge__s.html#details">More...</a><br/></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:ga3ee110c7c5d95cfe386b113d2d078ec3"><td class="memItemLeft" align="right" valign="top">typedef void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a></td></tr>
<tr class="memdesc:ga3ee110c7c5d95cfe386b113d2d078ec3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Handle to an external memory data transfer instance.  <a href="#ga3ee110c7c5d95cfe386b113d2d078ec3">More...</a><br/></td></tr>
<tr class="separator:ga3ee110c7c5d95cfe386b113d2d078ec3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga22177ad0d4d825d5ed3b26021634b221"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="../../dd/da7/structlib__emt__Config__s.html">lib_emt_Config_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga22177ad0d4d825d5ed3b26021634b221">lib_emt_Config_t</a></td></tr>
<tr class="memdesc:ga22177ad0d4d825d5ed3b26021634b221"><td class="mdescLeft">&#160;</td><td class="mdescRight">Configuration parameters for the initialization of external memory data transfer.  <a href="#ga22177ad0d4d825d5ed3b26021634b221">More...</a><br/></td></tr>
<tr class="separator:ga22177ad0d4d825d5ed3b26021634b221"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga437bfecb0c8f550b36bae0f0ee65702d"><td class="memItemLeft" align="right" valign="top">typedef struct <br class="typebreak"/>
<a class="el" href="../../d8/d98/structlib__emt__ConfigLarge__s.html">lib_emt_ConfigLarge_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a></td></tr>
<tr class="memdesc:ga437bfecb0c8f550b36bae0f0ee65702d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Configuration for large external memory data transfers.  <a href="#ga437bfecb0c8f550b36bae0f0ee65702d">More...</a><br/></td></tr>
<tr class="separator:ga437bfecb0c8f550b36bae0f0ee65702d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga0e8d22819c818e39a2bae0ea24bb567b"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga0e8d22819c818e39a2bae0ea24bb567b">lib_imt_copy</a> (const void *src, void *dst, size_t size)</td></tr>
<tr class="memdesc:ga0e8d22819c818e39a2bae0ea24bb567b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_imt_copy performs data transfers between any two internal memory locations local to the C66x CorePac: L1P, L1D, and L2. This function uses IDMA channel 1 to perform the transfer.  <a href="#ga0e8d22819c818e39a2bae0ea24bb567b">More...</a><br/></td></tr>
<tr class="separator:ga0e8d22819c818e39a2bae0ea24bb567b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8189ff38ebc25a3700ab04ffb612b1f2"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga8189ff38ebc25a3700ab04ffb612b1f2">lib_imt_set</a> (uint32_t pattern, void *dst, size_t size)</td></tr>
<tr class="memdesc:ga8189ff38ebc25a3700ab04ffb612b1f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_imt_set fills a block of internal memory, L1P, L1D, or L2 with a given pattern.  <a href="#ga8189ff38ebc25a3700ab04ffb612b1f2">More...</a><br/></td></tr>
<tr class="separator:ga8189ff38ebc25a3700ab04ffb612b1f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga320847c84fb1dd50ce67a1f5c5315043"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga320847c84fb1dd50ce67a1f5c5315043">lib_imt_wait</a> ()</td></tr>
<tr class="memdesc:ga320847c84fb1dd50ce67a1f5c5315043"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_imt_wait waits for completion of transfers started by lib_imt_copy or lib_imt_set.  <a href="#ga320847c84fb1dd50ce67a1f5c5315043">More...</a><br/></td></tr>
<tr class="separator:ga320847c84fb1dd50ce67a1f5c5315043"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga40fa4887611b6ceb4d57b9804d6b26fb"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga40fa4887611b6ceb4d57b9804d6b26fb">lib_emt_init</a> ()</td></tr>
<tr class="memdesc:ga40fa4887611b6ceb4d57b9804d6b26fb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_init performs all necessary initialization for external memory data transfers.  <a href="#ga40fa4887611b6ceb4d57b9804d6b26fb">More...</a><br/></td></tr>
<tr class="separator:ga40fa4887611b6ceb4d57b9804d6b26fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2d74d954ddeabe505cdc1caf5fc775bc"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc">lib_emt_alloc</a> (int32_t max_linked_transfers)</td></tr>
<tr class="memdesc:ga2d74d954ddeabe505cdc1caf5fc775bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_alloc allocates a channel to do external memory data transfers.  <a href="#ga2d74d954ddeabe505cdc1caf5fc775bc">More...</a><br/></td></tr>
<tr class="separator:ga2d74d954ddeabe505cdc1caf5fc775bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad8adc89232fa208dc86267a4885170ed"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed">lib_emt_allocLarge</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a> *cfg, IALG_MemRec *memTab)</td></tr>
<tr class="memdesc:gad8adc89232fa208dc86267a4885170ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_allocLarge allocates a data transfer channel for external "Large" 1D2D or 2D1D transfers which have a pitch outside the range [-32768,32768].  <a href="#gad8adc89232fa208dc86267a4885170ed">More...</a><br/></td></tr>
<tr class="separator:gad8adc89232fa208dc86267a4885170ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga01f4f02c995d8842a1b172670a97dc80"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga01f4f02c995d8842a1b172670a97dc80">lib_emt_getSizesLarge</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a> *cfg, IALG_MemRec *memTab)</td></tr>
<tr class="memdesc:ga01f4f02c995d8842a1b172670a97dc80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_getSizesLarge gets buffer requirements for a channel used to do large transfers.  <a href="#ga01f4f02c995d8842a1b172670a97dc80">More...</a><br/></td></tr>
<tr class="separator:ga01f4f02c995d8842a1b172670a97dc80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga97f5256765c92ada94fed76df35da8f8"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga97f5256765c92ada94fed76df35da8f8">lib_emt_free</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h)</td></tr>
<tr class="memdesc:ga97f5256765c92ada94fed76df35da8f8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_free frees a channel previously allocated for external memory data transfers.  <a href="#ga97f5256765c92ada94fed76df35da8f8">More...</a><br/></td></tr>
<tr class="separator:ga97f5256765c92ada94fed76df35da8f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadfa5407c4b9d573f3f67d072f8ee76da"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gadfa5407c4b9d573f3f67d072f8ee76da">lib_emt_wait</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h)</td></tr>
<tr class="memdesc:gadfa5407c4b9d573f3f67d072f8ee76da"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_wait waits for completion of external transfers started by lib_emt_copyxxx.  <a href="#gadfa5407c4b9d573f3f67d072f8ee76da">More...</a><br/></td></tr>
<tr class="separator:gadfa5407c4b9d573f3f67d072f8ee76da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabe9856fed82fa0fc911a9fdb43e494e1"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gabe9856fed82fa0fc911a9fdb43e494e1">lib_emt_copy1D1D</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src, void *restrict dst, int32_t num_bytes)</td></tr>
<tr class="memdesc:gabe9856fed82fa0fc911a9fdb43e494e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy1D1D performs a single 1D-&gt;1D data transfer in external memory.  <a href="#gabe9856fed82fa0fc911a9fdb43e494e1">More...</a><br/></td></tr>
<tr class="separator:gabe9856fed82fa0fc911a9fdb43e494e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7eac2e886fc99a5be1086cb0fa6d9d4e"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga7eac2e886fc99a5be1086cb0fa6d9d4e">lib_emt_copy1D2D</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</td></tr>
<tr class="memdesc:ga7eac2e886fc99a5be1086cb0fa6d9d4e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy1D2D performs a 1D-&gt;2D transfer.  <a href="#ga7eac2e886fc99a5be1086cb0fa6d9d4e">More...</a><br/></td></tr>
<tr class="separator:ga7eac2e886fc99a5be1086cb0fa6d9d4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab6426d5afb67b7e9b4a8cff88135ab3f"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gab6426d5afb67b7e9b4a8cff88135ab3f">lib_emt_copy2D1D</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</td></tr>
<tr class="memdesc:gab6426d5afb67b7e9b4a8cff88135ab3f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy2D1D performs a 2D-&gt;1D transfer.  <a href="#gab6426d5afb67b7e9b4a8cff88135ab3f">More...</a><br/></td></tr>
<tr class="separator:gab6426d5afb67b7e9b4a8cff88135ab3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga624053012144128867ef2a9ef808f264"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga624053012144128867ef2a9ef808f264">lib_emt_copy2D2D</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t src_pitch, int32_t dst_pitch)</td></tr>
<tr class="memdesc:ga624053012144128867ef2a9ef808f264"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy2D2D perform a 2D-&gt;2D transfer.  <a href="#ga624053012144128867ef2a9ef808f264">More...</a><br/></td></tr>
<tr class="separator:ga624053012144128867ef2a9ef808f264"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5f4e571bc160df4f1ccf934aaeaa325b"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga5f4e571bc160df4f1ccf934aaeaa325b">lib_emt_copy1D1DLinked</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_transfers)</td></tr>
<tr class="memdesc:ga5f4e571bc160df4f1ccf934aaeaa325b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy1D1DLinked performs a group of linked 1D-&gt;1D transfers.  <a href="#ga5f4e571bc160df4f1ccf934aaeaa325b">More...</a><br/></td></tr>
<tr class="separator:ga5f4e571bc160df4f1ccf934aaeaa325b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa0783528473328cd5a809bd528bea150"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gaa0783528473328cd5a809bd528bea150">lib_emt_copy1D2DLinked</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_lines[], int32_t pitch[], int32_t num_transfers)</td></tr>
<tr class="memdesc:gaa0783528473328cd5a809bd528bea150"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy1D2DLinked performs a group of linked 1D-&gt;2D transfers.  <a href="#gaa0783528473328cd5a809bd528bea150">More...</a><br/></td></tr>
<tr class="separator:gaa0783528473328cd5a809bd528bea150"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaae7bb385b41241410af0b5e917158e7b"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gaae7bb385b41241410af0b5e917158e7b">lib_emt_copy2D1DLinked</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_lines[], int32_t pitch[], int32_t num_transfers)</td></tr>
<tr class="memdesc:gaae7bb385b41241410af0b5e917158e7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy2D1DLinked performs a group of linked 2D-&gt;1D transfers.  <a href="#gaae7bb385b41241410af0b5e917158e7b">More...</a><br/></td></tr>
<tr class="separator:gaae7bb385b41241410af0b5e917158e7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaef9d8b5dd3d94847af102329ead8a081"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gaef9d8b5dd3d94847af102329ead8a081">lib_emt_copy2D2DLinked</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src[], void *restrict dst[], int32_t num_bytes[], int32_t num_lines[], int32_t src_pitch[], int32_t dst_pitch[], int32_t num_transfers)</td></tr>
<tr class="memdesc:gaef9d8b5dd3d94847af102329ead8a081"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy2D2DLinked performs a group of linked 2D-&gt;2D transfers.  <a href="#gaef9d8b5dd3d94847af102329ead8a081">More...</a><br/></td></tr>
<tr class="separator:gaef9d8b5dd3d94847af102329ead8a081"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1a987a6a5bddf31afc70ce6a0fbd17e1"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga1a987a6a5bddf31afc70ce6a0fbd17e1">lib_emt_copy1D2DLarge</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</td></tr>
<tr class="memdesc:ga1a987a6a5bddf31afc70ce6a0fbd17e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy1D2DLarge performs a 1D-&gt;2D transfer when destination pitch is large (outside the range of [-32768,32767]).  <a href="#ga1a987a6a5bddf31afc70ce6a0fbd17e1">More...</a><br/></td></tr>
<tr class="separator:ga1a987a6a5bddf31afc70ce6a0fbd17e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab1b291a6ce214301ed50b5731590e29a"><td class="memItemLeft" align="right" valign="top">static int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gab1b291a6ce214301ed50b5731590e29a">lib_emt_copy2D1DLarge</a> (<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> h, void *restrict src, void *restrict dst, int32_t num_bytes, int32_t num_lines, int32_t pitch)</td></tr>
<tr class="memdesc:gab1b291a6ce214301ed50b5731590e29a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function lib_emt_copy2D1DLarge performs a 2D-&gt;1D transfer when source pitch is large (outside the range of [-32768,32767]).  <a href="#gab1b291a6ce214301ed50b5731590e29a">More...</a><br/></td></tr>
<tr class="separator:gab1b291a6ce214301ed50b5731590e29a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6682ba347b624952140c5ead3301a8be"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga6682ba347b624952140c5ead3301a8be">LIB_EMT_SUCCESS</a>&#160;&#160;&#160;(0)</td></tr>
<tr class="memdesc:ga6682ba347b624952140c5ead3301a8be"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return error codes of external memory data transfer functions.  <a href="#ga6682ba347b624952140c5ead3301a8be">More...</a><br/></td></tr>
<tr class="separator:ga6682ba347b624952140c5ead3301a8be"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7c00744552e888fa1c1da7bafc3fb362"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga7c00744552e888fa1c1da7bafc3fb362">LIB_EMT_ERROR_INVARG</a>&#160;&#160;&#160;(-1)</td></tr>
<tr class="separator:ga7c00744552e888fa1c1da7bafc3fb362"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaec3d5fb167114b1c4dbf5d3a6220b0d1"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gaec3d5fb167114b1c4dbf5d3a6220b0d1">LIB_EMT_ERROR_INVCFG</a>&#160;&#160;&#160;(-2)</td></tr>
<tr class="separator:gaec3d5fb167114b1c4dbf5d3a6220b0d1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9189f70619c7a767d69d7fe8b9500e7e"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga9189f70619c7a767d69d7fe8b9500e7e">LIB_EMT_ERROR_RMANINIT</a>&#160;&#160;&#160;(-3)</td></tr>
<tr class="separator:ga9189f70619c7a767d69d7fe8b9500e7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7ca25bc939f597f627bc633b7256c05e"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga7ca25bc939f597f627bc633b7256c05e">LIB_EMT_ERROR_INVHANDLE</a>&#160;&#160;&#160;(-4)</td></tr>
<tr class="separator:ga7ca25bc939f597f627bc633b7256c05e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5262fd9542b2a9beb4f9b6a7c1215a95"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga5262fd9542b2a9beb4f9b6a7c1215a95">LIB_EMT_ERROR_FREE</a>&#160;&#160;&#160;(-5)</td></tr>
<tr class="separator:ga5262fd9542b2a9beb4f9b6a7c1215a95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga25622242e06ac967497797f20e3095dd"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga25622242e06ac967497797f20e3095dd">LIB_EMT_ERROR_XFER</a>&#160;&#160;&#160;(-6)</td></tr>
<tr class="separator:ga25622242e06ac967497797f20e3095dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>LibArch Data Transfers API provides functions to perform data transfers between two memory locations which can be internal memory or external memory: </p>
<ul>
<li>internal memory data transfer: transfer data between memory locations local to the C66x CorePac: L1P, L1D, and L2.</li>
<li>external memory data transfer: transfer data between internal and external (not local to C66x Core) memory locations or between two external memory locations.</li>
</ul>
<dl class="section remark"><dt>Remarks</dt><dd>Since LibArch data transfer API is based on DMA, users need to maintain cache coherence when transfer involves external memory. Refer to TMS320C66x DSP Cache User Guide for more information. </dd></dl>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a class="anchor" id="ga5262fd9542b2a9beb4f9b6a7c1215a95"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LIB_EMT_ERROR_FREE&#160;&#160;&#160;(-5)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Failure to free a resource. </p>

</div>
</div>
<a class="anchor" id="ga7c00744552e888fa1c1da7bafc3fb362"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LIB_EMT_ERROR_INVARG&#160;&#160;&#160;(-1)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Failure. Invalid argument. </p>

</div>
</div>
<a class="anchor" id="gaec3d5fb167114b1c4dbf5d3a6220b0d1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LIB_EMT_ERROR_INVCFG&#160;&#160;&#160;(-2)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Failure. Invalid configuration. </p>

</div>
</div>
<a class="anchor" id="ga7ca25bc939f597f627bc633b7256c05e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LIB_EMT_ERROR_INVHANDLE&#160;&#160;&#160;(-4)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Failure. Invalid handle. </p>

</div>
</div>
<a class="anchor" id="ga9189f70619c7a767d69d7fe8b9500e7e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LIB_EMT_ERROR_RMANINIT&#160;&#160;&#160;(-3)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Failure. RMAN initialization. </p>

</div>
</div>
<a class="anchor" id="ga25622242e06ac967497797f20e3095dd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LIB_EMT_ERROR_XFER&#160;&#160;&#160;(-6)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Failure to transfer. </p>

</div>
</div>
<a class="anchor" id="ga6682ba347b624952140c5ead3301a8be"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LIB_EMT_SUCCESS&#160;&#160;&#160;(0)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return error codes of external memory data transfer functions. </p>
<p>Success. No error. </p>

</div>
</div>
<h2 class="groupheader">Typedef Documentation</h2>
<a class="anchor" id="ga22177ad0d4d825d5ed3b26021634b221"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="../../dd/da7/structlib__emt__Config__s.html">lib_emt_Config_s</a>  <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga22177ad0d4d825d5ed3b26021634b221">lib_emt_Config_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Configuration parameters for the initialization of external memory data transfer. </p>
<dl class="section remark"><dt>Remarks</dt><dd>This configuration is used by function lib_emt_init. </dd></dl>

</div>
</div>
<a class="anchor" id="ga437bfecb0c8f550b36bae0f0ee65702d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="../../d8/d98/structlib__emt__ConfigLarge__s.html">lib_emt_ConfigLarge_s</a>  <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Configuration for large external memory data transfers. </p>
<dl class="section remark"><dt>Remarks</dt><dd>This configuration is used by functions lib_emt_getSizesLarge and lib_emt_allocLarge to prepare for lib_emt_copy2D1DLarge and lib_emt_copy1D2DLarge. </dd></dl>

</div>
</div>
<a class="anchor" id="ga3ee110c7c5d95cfe386b113d2d078ec3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void* <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Handle to an external memory data transfer instance. </p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga2d74d954ddeabe505cdc1caf5fc775bc"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> lib_emt_alloc </td>
          <td>(</td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>max_linked_transfers</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_alloc allocates a channel to do external memory data transfers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">max_linked_transfers</td><td>Maximum number of linked transfers which must be smaller than or equal to LIB_EMT_MAX_NUM_CHANNELS.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">NULL</td><td>Failure to allocate the channel due to lack of resources </td></tr>
    <tr><td class="paramname">non-NULL</td><td>The handle to the allocated channel</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga40fa4887611b6ceb4d57b9804d6b26fb" title="Function lib_emt_init performs all necessary initialization for external memory data transfers...">lib_emt_init()</a> must be called before this function can be called.</dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Linked transfer not yet implemented for K2G. </dd></dl>

</div>
</div>
<a class="anchor" id="gad8adc89232fa208dc86267a4885170ed"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a> lib_emt_allocLarge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a> *&#160;</td>
          <td class="paramname"><em>cfg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">IALG_MemRec *&#160;</td>
          <td class="paramname"><em>memTab</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_allocLarge allocates a data transfer channel for external "Large" 1D2D or 2D1D transfers which have a pitch outside the range [-32768,32768]. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cfg</td><td>Configuration for a channel to be allocated to do large 1D-&gt;2D or 2D-&gt;1D transfers. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">memTab</td><td>Pointer to the structure which holds the base address and properties of the buffer allocated by the user.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">NULL</td><td>Failure to allocate the channel </td></tr>
    <tr><td class="paramname">non-NULL</td><td>The handle to the allocated channel</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga40fa4887611b6ceb4d57b9804d6b26fb" title="Function lib_emt_init performs all necessary initialization for external memory data transfers...">lib_emt_init()</a> must be called before this function can be called. </dd>
<dd>
<a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga01f4f02c995d8842a1b172670a97dc80" title="Function lib_emt_getSizesLarge gets buffer requirements for a channel used to do large transfers...">lib_emt_getSizesLarge()</a> must be called and the requested buffer be allocated satisfying the requirements specified in memTab returned by <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga01f4f02c995d8842a1b172670a97dc80" title="Function lib_emt_getSizesLarge gets buffer requirements for a channel used to do large transfers...">lib_emt_getSizesLarge()</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="gabe9856fed82fa0fc911a9fdb43e494e1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy1D1D </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy1D1D performs a single 1D-&gt;1D data transfer in external memory. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src</td><td>Source address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>Destination address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes</td><td>Number of bytes to transfer</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">LIB_EMT_SUCCESS</td><td>Return error codes of external memory data transfer functions. Success. No error. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_INVCFG</td><td>Failure. Invalid configuration. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_XFER</td><td>Failure to transfer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>Perform a single 1D-&gt;1D transfer of <code>num_bytes</code> bytes from <code>src</code> address to <code>dst</code> address.</dd>
<dd>
Maximum transfer size is 65535 bytes.</dd></dl>
<dl class="section see"><dt>See Also</dt><dd><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga5f4e571bc160df4f1ccf934aaeaa325b" title="Function lib_emt_copy1D1DLinked performs a group of linked 1D-&gt;1D transfers. ">lib_emt_copy1D1DLinked</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga5f4e571bc160df4f1ccf934aaeaa325b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy1D1DLinked </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_transfers</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy1D1DLinked performs a group of linked 1D-&gt;1D transfers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src[]</td><td>Array of source addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst[]</td><td>Array of destination addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes[]</td><td>Array of number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_transfers</td><td>Number of transfers</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="section see"><dt>See Also</dt><dd><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gabe9856fed82fa0fc911a9fdb43e494e1" title="Function lib_emt_copy1D1D performs a single 1D-&gt;1D data transfer in external memory. ">lib_emt_copy1D1D</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga7eac2e886fc99a5be1086cb0fa6d9d4e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy1D2D </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>pitch</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy1D2D performs a 1D-&gt;2D transfer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src</td><td>Source address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>Destination (two dimensional) address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes</td><td>Number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines</td><td>Number of lines </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pitch</td><td>Pitch for destination address increment</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Perform a 1D-&gt;2D transfer of <code>num_bytes</code> bytes. The source is one dimensional, and the destination is two dimensional.</dd>
<dd>
After every line of <code>num_bytes</code> is transferred, the <code>src</code> address is incremented by <code>num_bytes</code> and the <code>dst</code> address is incremented by <code>pitch</code> bytes. </dd></dl>

</div>
</div>
<a class="anchor" id="ga1a987a6a5bddf31afc70ce6a0fbd17e1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy1D2DLarge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>pitch</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy1D2DLarge performs a 1D-&gt;2D transfer when destination pitch is large (outside the range of [-32768,32767]). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src</td><td>Source address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>Destination address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes</td><td>Number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines</td><td>Number of lines </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pitch</td><td>Pitch for destination address increment</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>.</dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Perform a 1D-&gt;2D transfer of <code>num_bytes</code> bytes. The source is one dimensional, and the destination is two dimensional.</dd>
<dd>
After every line of <code>num_bytes</code> is transferred, the <code>src</code> address is incremented by <code>num_bytes</code> and the <code>dst</code> address is incremented by <code>pitch</code> bytes.</dd>
<dd>
This should be used when the pitch is outside the range of [-32768,32767]. </dd></dl>

</div>
</div>
<a class="anchor" id="gaa0783528473328cd5a809bd528bea150"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy1D2DLinked </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>pitch</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_transfers</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy1D2DLinked performs a group of linked 1D-&gt;2D transfers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src[]</td><td>Array of source addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst[]</td><td>Array of destination addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes[]</td><td>Array of number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines[]</td><td>Array of lines to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pitch[]</td><td>Array of pitches for destination address increment </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_transfers</td><td>Number of transfers</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="section see"><dt>See Also</dt><dd><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga7eac2e886fc99a5be1086cb0fa6d9d4e" title="Function lib_emt_copy1D2D performs a 1D-&gt;2D transfer. ">lib_emt_copy1D2D</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gab6426d5afb67b7e9b4a8cff88135ab3f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy2D1D </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>pitch</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy2D1D performs a 2D-&gt;1D transfer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src</td><td>Source (two dimensional) address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>Destination address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes</td><td>Number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines</td><td>Number of lines </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pitch</td><td>Pitch for source address increment</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Perform a 2D-&gt;1D transfer of <code>num_bytes</code> bytes. The source is two dimensional, and the destination is one dimensional.</dd>
<dd>
After every line of <code>num_bytes</code> is transferred, the <code>src</code> address is incremented by <code>pitch</code> and the <code>dst</code> address is incremented by <code>num_bytes</code> bytes. </dd></dl>

</div>
</div>
<a class="anchor" id="gab1b291a6ce214301ed50b5731590e29a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy2D1DLarge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>pitch</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy2D1DLarge performs a 2D-&gt;1D transfer when source pitch is large (outside the range of [-32768,32767]). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src</td><td>Source address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>Destination address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes</td><td>Number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines</td><td>Number of lines </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pitch</td><td>Pitch</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>.</dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Perform a 2D-&gt;1D transfer of <code>num_bytes</code> bytes. The source is two dimensional, and the destination is one dimensional.</dd>
<dd>
After every line of <code>num_bytes</code> is transferred, the <code>src</code> address is incremented by <code>pitch</code> and the <code>dst</code> address is incremented by <code>num_bytes</code> bytes.</dd>
<dd>
This should be used when the pitch is outside the range of [-32768,32767]. </dd></dl>

</div>
</div>
<a class="anchor" id="gaae7bb385b41241410af0b5e917158e7b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy2D1DLinked </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>pitch</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_transfers</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy2D1DLinked performs a group of linked 2D-&gt;1D transfers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src[]</td><td>Array of source addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst[]</td><td>Array of destination addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes[]</td><td>Array of number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines[]</td><td>Array of lines to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pitch[]</td><td>Array of pitches for source address increment </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_transfers</td><td>Number of transfers</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="section see"><dt>See Also</dt><dd><a class="el" href="../../d1/df3/group__libarch__datatrans.html#gab6426d5afb67b7e9b4a8cff88135ab3f" title="Function lib_emt_copy2D1D performs a 2D-&gt;1D transfer. ">lib_emt_copy2D1D</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga624053012144128867ef2a9ef808f264"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy2D2D </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>src_pitch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>dst_pitch</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy2D2D perform a 2D-&gt;2D transfer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src</td><td>Source address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>Destination address </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes</td><td>Number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines</td><td>Number of lines </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src_pitch</td><td>Pitch for source address increment </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst_pitch</td><td>Pitch for destination address increment</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">LIB_EMT_SUCCESS</td><td>Return error codes of external memory data transfer functions. Success. No error. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_INVCFG</td><td>Failure. Invalid configuration. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_XFER</td><td>Failure to transfer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Perform a 2D-&gt;2D transfer of <code>num_bytes</code> bytes. The source and destination are both two dimensional.</dd>
<dd>
After every line of <code>num_bytes</code> is transferred, the <code>src</code> address is incremented by <code>src_pitch</code> bytes and the <code>dst</code> address is incremented by <code>dst_pitch</code> bytes. </dd></dl>

</div>
</div>
<a class="anchor" id="gaef9d8b5dd3d94847af102329ead8a081"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_copy2D2DLinked </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>src</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *restrict&#160;</td>
          <td class="paramname"><em>dst</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_bytes</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_lines</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>src_pitch</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>dst_pitch</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>num_transfers</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_copy2D2DLinked performs a group of linked 2D-&gt;2D transfers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src[]</td><td>Array of source addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst[]</td><td>Array of destination addresses </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_bytes[]</td><td>Array of number of bytes to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_lines[]</td><td>Array of lines to transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src_pitch[]</td><td>Array of source pitches </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst_pitch[]</td><td>Array of destination pitches </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num_transfers</td><td>Number of transfers</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Always</td><td>Return error codes of external memory data transfer functions. Success. No error.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a>.</dd></dl>
<dl class="section see"><dt>See Also</dt><dd>lib_emt_copy2D2DSep </dd></dl>

</div>
</div>
<a class="anchor" id="ga97f5256765c92ada94fed76df35da8f8"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_free </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_free frees a channel previously allocated for external memory data transfers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a> or <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">LIB_EMT_SUCCESS</td><td>Return error codes of external memory data transfer functions. Success. No error. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_INVHANDLE</td><td>Failure. Invalid handle. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_FREE</td><td>Failure to free a resource.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a> or <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga01f4f02c995d8842a1b172670a97dc80"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_getSizesLarge </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga437bfecb0c8f550b36bae0f0ee65702d">lib_emt_ConfigLarge_t</a> *&#160;</td>
          <td class="paramname"><em>cfg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">IALG_MemRec *&#160;</td>
          <td class="paramname"><em>memTab</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_getSizesLarge gets buffer requirements for a channel used to do large transfers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cfg</td><td>Configuration for a channel to be allocated to do large 1D-&gt;2D or 2D-&gt;1D transfers. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">memTab</td><td>Returned structure that holds the buffer requirements for a channel to do large 1D-&gt;2D or 2D-&gt;1D transfers.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">LIB_EMT_SUCCESS</td><td>Return error codes of external memory data transfer functions. Success. No error. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_INVCFG</td><td>Failure. Invalid configuration.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>The returned array memTab has only one element in it. A buffer satisfying the requirements specified in memTab[0] must be provided to <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a> along with the corresponding lib_emt_ConfigLarge_t structure. </dd></dl>

</div>
</div>
<a class="anchor" id="ga40fa4887611b6ceb4d57b9804d6b26fb"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int lib_emt_init </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_init performs all necessary initialization for external memory data transfers. </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">LIB_EMT_SUCCESS</td><td>Return error codes of external memory data transfer functions. Success. No error. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_INVARG</td><td>Failure. Invalid argument. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_INVCFG</td><td>Failure. Invalid configuration. </td></tr>
    <tr><td class="paramname">LIB_EMT_ERROR_RMANINIT</td><td>Failure. RMAN initialization. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gadfa5407c4b9d573f3f67d072f8ee76da"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int32_t lib_emt_wait </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga3ee110c7c5d95cfe386b113d2d078ec3">lib_emt_Handle</a>&#160;</td>
          <td class="paramname"><em>h</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_emt_wait waits for completion of external transfers started by lib_emt_copyxxx. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">h</td><td>Handle returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a> or <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section pre"><dt>Precondition</dt><dd><code>h</code> must be a handle successfully returned from <a class="el" href="../../d1/df3/group__libarch__datatrans.html#ga2d74d954ddeabe505cdc1caf5fc775bc" title="Function lib_emt_alloc allocates a channel to do external memory data transfers. ">lib_emt_alloc()</a> or <a class="el" href="../../d1/df3/group__libarch__datatrans.html#gad8adc89232fa208dc86267a4885170ed" title="Function lib_emt_allocLarge allocates a data transfer channel for external &quot;Large&quot; 1D2D or 2D1D trans...">lib_emt_allocLarge()</a>.</dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>This function waits for all transfers on a specific channel to complete. It is a blocking call. </dd></dl>

</div>
</div>
<a class="anchor" id="ga0e8d22819c818e39a2bae0ea24bb567b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void lib_imt_copy </td>
          <td>(</td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_imt_copy performs data transfers between any two internal memory locations local to the C66x CorePac: L1P, L1D, and L2. This function uses IDMA channel 1 to perform the transfer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">src</td><td>source address of transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>destination address of transfer </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">size</td><td>size of transfer in minimum access units</td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>This function waits for the pending transfer (if any) to become active. It is a blocking call. </dd>
<dd>
There is no need to allocate a channel before using this function. </dd>
<dd>
Both source and destination addresses increment linearly throughout the transfer. </dd>
<dd>
No DSP interrupt is generated after the transfer. Function lib_imt_wait can be called to wait for transfer completion before data in destination memory is used. </dd>
<dd>
During any conflicts between CPU and DMA accesses, transfer started by this function has the lowest priority. </dd></dl>

</div>
</div>
<a class="anchor" id="ga8189ff38ebc25a3700ab04ffb612b1f2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void lib_imt_set </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>pattern</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_imt_set fills a block of internal memory, L1P, L1D, or L2 with a given pattern. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pattern</td><td>Filling pattern </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst</td><td>Address of the memory to be filled </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">size</td><td>size of memory filling in minimum access units</td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>This function waits for the pending transfer to become active. It is a blocking call. </dd>
<dd>
Refer to remarks of lib_imt_copy. </dd></dl>

</div>
</div>
<a class="anchor" id="ga320847c84fb1dd50ce67a1f5c5315043"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void lib_imt_wait </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function lib_imt_wait waits for completion of transfers started by lib_imt_copy or lib_imt_set. </p>
<dl class="section remark"><dt>Remarks</dt><dd>This function waits for both pending and active transfers to complete. It is a blocking call. </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Mar 6 2017 14:10:51 for LibArch by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="../../doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
